Subject: Re: [pcp] A question: How can an internal client get the external IP and port of the inner NAT

From: Chenguohai <[email-masked]>
Date: Mon, 26 Oct 2015 01:54:52 +0000

Hi Dan,

Thank again.
What is the workflow in nested NATs for internal host?
1: the client must judge how many NATs are there in the path and the order;
2: nogotiate with the fisrt PCP server(in the most nested NAT) for the exteral IP and port;
3:use the negotiated IP and port with the second PCP server;
4 do step 2 and 3 until communicating to the most external PCP server.

Does this make sense?

BR
G.Robert  Chen
-------------------------------------------------------------------------------------------------------------------------------------

发件人: 🔓Dan Wing [mailto:[email-masked]]
发送时间: 2015年10月24日 23:54
收件人: ChenGuohai
抄送: Chenguohai; [email-masked]
主题: Re: [pcp] A question: How can an internal client get the external IP and port of the inner NAT

On 23-Oct-2015 06:04 pm, ChenGuohai <[email-masked]<mailto:[email-masked]>> wrote:
Hi Dan,

Many thanks for your explaination.

Inner NATs are mostly used in residents and external NATs are CGNs is the most common nested NAT case.

Using PCP means that the CPE(inner NAT) must embed a PCP server.  The PCP client should communicats with two PCP servers.

Right.

Using STUN means a STUN server need to be deployed between inner NAT and external NAT. Shall this be common?

Not that I have seen.

-d

Manual configuration is very cost.

BR
G.Robert  Chen

________________________________
Subject: Re: [pcp] A question: How can an internal client get the external IP and port of the inner NAT
From: [email-masked]<mailto:[email-masked]>
Date: Fri, 23 Oct 2015 10:44:15 -0700
CC: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
To: [email-masked]<mailto:[email-masked]>

On 22-Oct-2015 08:24 pm, Chenguohai <[email-masked]<mailto:[email-masked]>> wrote:

Hi all,
I am new to PCP and reading RFC6887.I have a question about section 8.1. On the upper part of page 22 writing following,
the PCP-controlled NAT creating pointless non-functional mappings.
   When such an intervening non-PCP-aware inner NAT is detected,
   mappings must first be created by some other means in the inner NAT,
   before mappings can be usefully created in the outer PCP-controlled
   NAT.  Having created mappings in the inner NAT by some other means,
   the PCP client should then use the inner NAT’s external address as
   the client IP address, to signal to the outer PCP-controlled NAT that
   the client is aware of the inner NAT, and has taken steps to create
   mappings in it by some other means, so that mappings created in the
   outer NAT will not be a pointless waste of resources.

My question is that how an interal client could get the external IP and port of the inner NAT.

PCP, UPnP IGD, STUN, manual configuration.

Should there be server between the inner NAT and the external one? How could it be assured that the inner NAT does not change external port?

Hopefully whatever mechanism the client used (PCP, UPnP IGD, STUN, manual configuration) would tell the client of such a change.

-d

BR
G.Robert  Chen
-------------------------------------------------------------------------------------------------------------------------------------
G.Robert  Chen (Chen Guohai  陈国海). Network Research Department, Huawei Technologies Co., Ltd. Telephone: 0086-25-56624606;   http://www.huawei.com<http://www.huawei.com/>
-------------------------------------------------------------------------------------------------------------------------------------
This e-mail and its attachments contain confidential information from HUAWEI, which is intended only for the person or entity whose address is listed above. Any use of the  information contained herein in any way (including, but not limited to, total or partial disclosure, reproduction, or dissemination) by persons other than the intended recipient(s) is prohibited. If you receive this e-mail in error, please notify the sender by phone or email immediately and delete it!
----------------------------------------------------------------------------------------------------------------------------------------

_______________________________________________
pcp mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/pcp

---

From: 🔓Dan Wing <[email-masked]>
Date: Mon, 26 Oct 2015 09:57:11 -0700

> 1: the client must judge how many NATs are there in the path and the order;

It doesn't need to perform (1) first.  In fact, it's impossible to determine how many NATs are on the path first.

> 4 do step 2 and 3 until communicating to the most external PCP server.

Correct.  And after doing that, it will have determined how many PCP-supporting NATs are on the path.

> Does this make sense?

Yes.

-d

> On 23-Oct-2015 06:04 pm, ChenGuohai <[email-masked] <mailto:[email-masked]>> wrote:
> Hi Dan,
>  
> From: [email-masked] <mailto:[email-masked]>
> CC: [email-masked] <mailto:[email-masked]>; [email-masked] <mailto:[email-masked]>
> To: [email-masked] <mailto:[email-masked]>
> 
> On 22-Oct-2015 08:24 pm, Chenguohai <[email-masked] <mailto:[email-masked]>> wrote:
>  
>  
> Hi all,
> G.Robert  Chen (Chen Guohai  陈国海). Network Research Department, Huawei Technologies Co., Ltd. Telephone: 0086-25-56624606;   http://www.huawei.com <http://www.huawei.com/>
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/pcp <https://www.ietf.org/mailman/listinfo/pcp>
>  
>  
>  
>

---

From: Chenguohai <[email-masked]>
Date: Tue, 27 Oct 2015 01:10:38 +0000

Hi Dan,

If step one is not needed, then,
How does a client stop negotiating?  Based on global routable  IP address or something else?
Does a NAT know that itself is the most exteral?

BR
G.Robert  Chen

发件人: 🔓Dan Wing [mailto:[email-masked]]
发送时间: 2015年10月27日 0:57
收件人: Chenguohai
抄送: ChenGuohai; [email-masked]
主题: Re: [pcp] A question: How can an internal client get the external IP and port of the inner NAT

On 25-Oct-2015 06:54 pm, Chenguohai <[email-masked]<mailto:[email-masked]>> wrote:

Hi Dan,

Thank again.

Does this make sense?

Yes.

-d

BR
G.Robert  Chen

发件人: 🔓Dan Wing [mailto:[email-masked]]
发送时间: 2015年10月24日 23:54
收件人: ChenGuohai
抄送: Chenguohai; [email-masked]<mailto:[email-masked]>
主题: Re: [pcp] A question: How can an internal client get the external IP and port of the inner NAT

Right.

Not that I have seen.

-d

BR
G.Robert  Chen

Hi all,

-d

BR
G.Robert  Chen

---

From: <[email-masked]>
Date: Tue, 27 Oct 2015 07:19:18 +0000

Hi Chen,

FWIW, you may read this document: https://tools.ietf.org/html/draft-penno-pcp-nested-nat-03. The content is not that “fresh”, but it discusses some sample configurations (PCP-unaware NAT, PCP-aware NAT, etc.)

In case all your NATs are PCP-aware, you may read https://tools.ietf.org/html/rfc7648#section-1.1. The recursion can be terminated as detailed in: https://tools.ietf.org/html/rfc7648#section-3.2.

Cheers,
Med

De : pcp [mailto:[email-masked]] De la part de Chenguohai
Envoyé : lundi 26 octobre 2015 02:55
À : 🔓Dan Wing; ChenGuohai
Cc : [email-masked]
Objet : Re: [pcp] A question: How can an internal client get the external IP and port of the inner NAT

Hi Dan,

Thank again.

Does this make sense?

BR
G.Robert  Chen

Right.

Not that I have seen.

-d

BR
G.Robert  Chen

Hi all,

-d

BR
G.Robert  Chen

---

From: Chenguohai <[email-masked]>
Date: Tue, 27 Oct 2015 09:19:37 +0000

Hi Med,

Thanks for providing these links.
Your draft provides many methods valuable for rolling PCP out because many deployed NATs are PCP unware. How about these options progressed. I did not found these options in other material.

I also found valuable method terminating resursion in  https://tools.ietf.org/html/rfc7648#section-3.2.

BR
G.Robert  Chen
-------------------------------------------------------------------------------------------------------------------------------------
G.Robert  Chen (Chen Guohai  陈国海). Network Research Department, Huawei Technologies Co., Ltd. Telephone: 0086-25-56624606;   http://www.huawei.com
-------------------------------------------------------------------------------------------------------------------------------------
This e-mail and its attachments contain confidential information from HUAWEI, which is intended only for the person or entity whose address is listed above. Any use of the  information contained herein in any way (including, but not limited to, total or partial disclosure, reproduction, or dissemination) by persons other than the intended recipient(s) is prohibited. If you receive this e-mail in error, please notify the sender by phone or email immediately and delete it!
----------------------------------------------------------------------------------------------------------------------------------------

发件人: [email-masked] [mailto:[email-masked]]
发送时间: 2015年10月27日 15:19
收件人: Chenguohai; 🔓Dan Wing; ChenGuohai
抄送: [email-masked]
主题: RE: [pcp] A question: How can an internal client get the external IP and port of the inner NAT

Hi Chen,

Cheers,
Med

Cc : [email-masked]<mailto:[email-masked]>

Hi Dan,

Thank again.

Does this make sense?

BR
G.Robert  Chen

Right.

Not that I have seen.

-d

BR
G.Robert  Chen

Hi all,

-d

BR
G.Robert  Chen

---

From: 🔓Dan Wing <[email-masked]>
Date: Tue, 27 Oct 2015 09:13:16 -0700

> Your draft provides many methods valuable for rolling PCP out because many deployed NATs are PCP unware. How about these options progressed. I did not found these options in other material.

Can you draw a network diagram, showing the clients, showing PCP- and PCP-unaware NATs, and showing the Internet?

-d

>  
> I also found valuable method terminating resursion in  https://tools.ietf.org/html/rfc7648#section-3.2 <https://tools.ietf.org/html/rfc7648#section-3.2>.
>  
> BR
> G.Robert  Chen
> FWIW, you may read this document: https://tools.ietf.org/html/draft-penno-pcp-nested-nat-03 <https://tools.ietf.org/html/draft-penno-pcp-nested-nat-03>. The content is not that “fresh”, but it discusses some sample configurations (PCP-unaware NAT, PCP-aware NAT, etc.)
>  
> In case all your NATs are PCP-aware, you may read https://tools.ietf.org/html/rfc7648#section-1.1 <https://tools.ietf.org/html/rfc7648#section-1.1>. The recursion can be terminated as detailed in: https://tools.ietf.org/html/rfc7648#section-3.2 <https://tools.ietf.org/html/rfc7648#section-3.2>.  
>  
> Cheers,
> Med
>  
> De : pcp [mailto:[email-masked] <mailto:[email-masked]>] De la part de Chenguohai
> Cc : [email-masked] <mailto:[email-masked]>
> 发件人: 🔓Dan Wing [mailto:[email-masked] <mailto:[email-masked]>] 
> 发送时间: 2015年10月24日 23:54
> 收件人: ChenGuohai
> 抄送: Chenguohai; [email-masked] <mailto:[email-masked]>

---

From: Chenguohai <[email-masked]>
Date: Wed, 28 Oct 2015 00:53:25 +0000

Hi Dan,
There are several examples in the draft  https://tools.ietf.org/html/draft-penno-pcp-nested-nat-03.

BR
G.Robert  Chen

发件人: 🔓Dan Wing [mailto:[email-masked]]
发送时间: 2015年10月28日 0:13
收件人: Chenguohai
抄送: Mohamed Boucadair; ChenGuohai; [email-masked]
主题: Re: [pcp] A question: How can an internal client get the external IP and port of the inner NAT

On 27-Oct-2015 02:19 am, Chenguohai <[email-masked]<mailto:[email-masked]>> wrote:

Hi Med,

-d

BR
G.Robert  Chen

发件人: [email-masked]<mailto:[email-masked]> [mailto:[email-masked]]
发送时间: 2015年10月27日 15:19
收件人: Chenguohai; 🔓Dan Wing; ChenGuohai
抄送: [email-masked]<mailto:[email-masked]>
主题: RE: [pcp] A question: How can an internal client get the external IP and port of the inner NAT

Hi Chen,

Cheers,
Med

Hi Dan,

Thank again.

Does this make sense?

BR
G.Robert  Chen

Right.

Not that I have seen.

-d

BR
G.Robert  Chen

Hi all,

-d

BR
G.Robert  Chen